"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-undef */
var _1 = require(".");
describe('Stack', function () {
    var s1;
    var s2;
    beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, _1.createStack)({ app: 'test' })];
                case 1:
                    s1 = _a.sent();
                    return [4 /*yield*/, (0, _1.createStack)({ app: 'test' })];
                case 2:
                    s2 = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('write/read', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, data, on, get, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, s2.node('hello')];
                case 1:
                    _a = _c.sent(), data = _a.data, on = _a.on, get = _a.get;
                    return [4 /*yield*/, s1.node('hello')];
                case 2:
                    _c.sent();
                    on(function (data) { return expect(data).toBe('world'); });
                    expect(data).toBe('world');
                    _b = expect;
                    return [4 /*yield*/, get()];
                case 3:
                    _b.apply(void 0, [_c.sent()]).toBe('world');
                    return [2 /*return*/];
            }
        });
    }); });
    test('node put file', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, data, on, get, putFile, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, s1.node('hello')];
                case 1:
                    _a = _c.sent(), data = _a.data, on = _a.on, get = _a.get, putFile = _a.putFile;
                    on(function (data) { return expect(data).toBe('world'); });
                    expect(data).toBe('world');
                    _b = expect;
                    return [4 /*yield*/, get()];
                case 2:
                    _b.apply(void 0, [_c.sent()]).toBe('world');
                    putFile({
                        type: 'text/plain',
                        size: 1,
                        data: __spreadArray([], __read(Buffer.from('a')), false)
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    test('node get file', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a, data, on, get, file, _b, _c, _d, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0: return [4 /*yield*/, s1.node('hello')];
                case 1:
                    _a = _f.sent(), data = _a.data, on = _a.on, get = _a.get, file = _a.file;
                    on(function (data) { return expect(data).toBe('world'); });
                    expect(data).toBe('world');
                    _b = expect;
                    return [4 /*yield*/, get()];
                case 2:
                    _b.apply(void 0, [_f.sent()]).toBe('world');
                    _c = expect;
                    _e = (_d = Buffer).from;
                    return [4 /*yield*/, file()];
                case 3:
                    _c.apply(void 0, [_e.apply(_d, [(_f.sent()).data]).toString()]).toBe('a');
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=index.test.js.map